;=== Defines
# DEFiNE
;===
!define 32    ProcessLasso\ProcessLassoLauncher.exe
!define 64    ProcessLasso64\ProcessLassoLauncher.exe
;===
!define EXE32 `$EXEDIR\App\${32}`
!define EXE64 `$EXEDIR\App\${64}`
;===
!define SET32 `Kernel32::SetEnvironmentVariable(t "PROCESSLASSO", t "ProcessLasso")`
!define SET64 `Kernel32::SetEnvironmentVariable(t "PROCESSLASSO", t "ProcessLasso64")`
;===
!define REG    `${SET}\ProcessLasso_CU.reg`
!define DEFREG `${DEFSET}\ProcessLasso_CU.reg`
!define XPATH  `/cfg/section[@name="Language"]/File`
;===
!define REG2    `${SET}\ProcessLasso_LM.reg`
!define DEFREG2 `${DEFSET}\ProcessLasso_LM.reg`
;===
;!define LOGS   `${DATA}\logs`
;===
;!define CFG    `${DATA}\config`
;!define DEFCFG `${DEFDATA}\config`
;===
!define PFM    `$R0\PortableApps.com\PortableAppsPlatform.exe`
;===
Function GetLCID
	!macro _GetLCID _LNG _LCID
		Push ${_LNG}
		Call GetLCID
		Pop ${_LCID}
	!macroend
	!define GetLCID "!insertmacro _GetLCID"
	Exch $R0
	StrCmp $R0 bGFuZy1lbi54bWw= 0 +3
	StrCpy $R0 1033
		Goto EndLCID
	StrCmp $R0 bGFuZy1mci54bWw= 0 +3
	StrCpy $R0 1036
		Goto EndLCID
	StrCmp $R0 bGFuZy1kZS54bWw= 0 +3
	StrCpy $R0 1031
		Goto EndLCID
	StrCmp $R0 bGFuZy1lcy54bWw= 0 +3
	StrCpy $R0 1034
		Goto EndLCID
	StrCmp $R0 bGFuZy1jbi54bWw= 0 +3
	StrCpy $R0 2052
		Goto +2
	StrCpy $R0 1033
	EndLCID:
	Exch $R0
FunctionEnd
Function GetLNG
	!macro _GetLNG _LCID _LNG
		Push ${_LCID}
		Call GetLNG
		Pop ${_LNG}
	!macroend
	!define GetLNG "!insertmacro _GetLNG"
	Exch $R0
	StrCmp $R0 1033 0 +3
	StrCpy $R0 bGFuZy1lbi54bWw=
		Goto EndLNG
	StrCmp $R0 1036 0 +3
	StrCpy $R0 bGFuZy1mci54bWw=
		Goto EndLNG
	StrCmp $R0 1031 0 +3
	StrCpy $R0 bGFuZy1kZS54bWw=
		Goto EndLNG
	StrCmp $R0 1034 0 +3
	StrCpy $R0 bGFuZy1lcy54bWw=
		Goto EndLNG
	StrCmp $R0 2052 0 +3
	StrCpy $R0 bGFuZy1jbi54bWw=
		Goto +2
	StrCpy $R0 error
	EndLNG:
	Exch $R0
FunctionEnd
;=== Custom
${SegmentFile}
${Segment.OnInit}
	Push $0
    System::Call `kernel32::GetCurrentProcess()i.s`
    System::Call `kernel32::IsWow64Process(is,*i.r0)`
    Pop $0
	StrCmp $0 0 ThirtyTwoBit
	IfFileExists `${EXE64}` 0 EightySixBit
	SetRegView 64
	System::Call `${SET64}`
	${WriteSettings} 64 Architecture
		Goto END
	EightySixBit:
	System::Call `${SET32}`
	${WriteSettings} 64 Architecture
		Goto END
	ThirtyTwoBit:
	System::Call `${SET32}`
	${WriteSettings} 32 Architecture
	END:
	Pop $0
!macroend
;===
!macro ProExecInit
	Push $0
	ReadEnvStr $0 ${APP}
	StrCmp $0 ${APP} 0 +3
	StrCpy $ProgramExecutable ${32}
	Goto +2
	StrCpy $ProgramExecutable ${64}
	Pop $0
!macroend
;===
!define MsgBox "!insertmacro MsgBox"
!macro MsgBox
	StrCpy $0 `Windows Vista +`
	MessageBox MB_ICONSTOP|MB_TOPMOST `$(MINREQ)`
	Call Unload
	Quit
!macroend
!macro OS
	Push $0
	${If} ${IsNT}
		${IfNot} ${AtLeastWinVista}
			${MsgBox}
		${EndIf}
	${Else}
		${MsgBox}
	${EndIf}
	Pop $0
!macroend
;===
!define PAL:LanguageLCID "!insertmacro PAL:LanguageLCID"
!macro PAL:LanguageLCID
	${GetLCID} $R0 $R0
	${SetEnvironmentVariable} PAL:LanguageLCID $R0
!macroend
!macro Lang
	Push $R0
	${GetParent} `$EXEDIR` $R0
	${If} ${FileExists} `${PFM}`
		ReadEnvStr $R0 PAL:LanguageLCID
		${GetLNG} $R0 $R0
		${If} $R0 == error
			${PAL:LanguageLCID}
		${EndIf}
	${Else}
		${PAL:LanguageLCID}
	${EndIf}
	Pop $R0
!macroend
;===
!macro LangInit
	Push $R0
	ReadEnvStr $R0 PAL:LanguageLCID
	${GetLNG} $R0 $R0
	${SetEnvironmentVariable} PAL:LanguageCustom $R0
	Pop $R0
!macroend
;===
!macro Init
	Push $0
	IfFileExists `${DOC}` +2
	CreateDirectory `${DOC}`
	IfFileExists `${REG}` +2
	CopyFiles /SILENT `${DEFREG}` `${REG}`
	IfFileExists `${REG2}` +2
	CopyFiles /SILENT `${DEFREG2}` `${REG2}`

!macroend
${SegmentPostPrimary}
	SetRegView 64
	DeleteRegKey /IFEMPTY HKLM `SOFTWARE\ProcessLasso\Counters`
        DeleteRegKey /IFEMPTY HKLM `SOFTWARE\ProcessLasso`
        DeleteRegKey /IFEMPTY HKLM `SOFTWARE\Wow6432Node\ProcessLasso\Language`
        DeleteRegKey /IFEMPTY HKLM `SOFTWARE\Wow6432Node\ProcessLasso`
        DeleteRegKey /IFEMPTY HKCU `Software\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Compatibility Assistant\Persisted`
        	Pop $0
		SetRegView LastUsed
!macroend
